#define NRANSI
#include "nrutil.h"
#define TOL 2.0e-4

#include "callback.h"

int ncom;
float *pcom,*xicom,(*nrfunc)(float [],void *);
void (*nrcallback)();
void *nrcbarg;

void linmin(float p[], float xi[], int n, float *fret, float (*func)(float [],void *),
		callback_t callback,void *cb_arg)
{
	float brent(float ax, float bx, float cx,
		float (*f)(float), float tol, float *xmin);
	float f1dim(float x);
	void mnbrak(float *ax, float *bx, float *cx, float *fa, float *fb,
		float *fc, float (*func)(float));
	int j;
	float xx,xmin,fx,fb,fa,bx,ax;

	ncom=n;
	pcom=vector(1,n);
	xicom=vector(1,n);
	nrfunc=func;
	nrcallback = callback;
	nrcbarg = cb_arg;
	for (j=1;j<=n;j++) {
		pcom[j]=p[j];
		xicom[j]=xi[j];
	}
	ax=0.0;
	xx=1.0;
	mnbrak(&ax,&xx,&bx,&fa,&fx,&fb,f1dim);
	callback(CB_ACTION_LINSTART,cb_arg);
	*fret=brent(ax,xx,bx,f1dim,TOL,&xmin);
	callback(CB_ACTION_LINSTOP,cb_arg);
	for (j=1;j<=n;j++) {
		xi[j] *= xmin;
		p[j] += xi[j];
	}
	free_vector(xicom,1,n);
	free_vector(pcom,1,n);
}
#undef TOL
#undef NRANSI
/* (C) Copr. 1986-92 Numerical Recipes Software 0N2. */
